Package ec.select

# Class BestSelection

java.lang.Object
ec.BreedingSource
ec.SelectionMethod
ec.select.BestSelection

All Implemented Interfaces:
  `Prototype`, `Setup`, `RandomChoiceChooserD`, `Serializable`, `Cloneable`

public class BestSelection extends SelectionMethod
Performs a tournament selection restricted to only the best, or worst, n indivdiuals in the population. If the best individuals, then tournament selection will prefer the better among them; if the worst individuals, then tournament selection will prefer the worse among them. The procedure for performing restriction is expensive to set up and bring down, so it's not appropriate for steady-state evolution. Like TournamentSelection, the size of the tournament can be any If you're not familiar with the relative advantages of selection methods and just want a good one, use TournamentSelection instead. Not appropriate for multiobjective fitnesses.

The tournament size can be any floating point value >= 1.0. If it is a non- integer value x then either a tournament of size ceil(x) is used (with probability x - floor(x)), else a tournament of size floor(x) is used.

Typical Number of Individuals Produced Per `produce(...)` call
Always 1.

Parameters

base.`pick-worst` bool = `true` or `false` (default) | (should we pick from among the worst n individuals in the tournament instead of the best n?)
base.`size` double >= 1 | (the tournament size)
base.`n` int > 0 | (the number of best-individuals to select from)
base.`n-fraction` 0.0 invalid input: '<'= double invalid input: '<' 1.0 (default is 1) | (the number of best-individuals to select from, as a fraction of the total population)

Default Base
select.best

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `int`
  `bestn`
  `double`
  `bestnFrac`
  `static final int`
  `NOT_SET`
  `static final String`
  `P_BEST`
  Default base
  `static final String`
  `P_N`
  `static final String`
  `P_N_FRACTION`
  `static final String`
  `P_PICKWORST`
  `static final String`
  `P_SIZE`
  `boolean`
  `pickWorst`
  Do we pick the worst instead of the best?
  `double`
  `probabilityOfPickingSizePlusOne`
  Probablity of picking the size plus one.
  `int`
  `size`
  Base size of the tournament; this may change.
  `int[]`
  `sortedPop`
  Sorted, normalized, totalized fitnesses for the population

  ### Fields inherited from class ec.SelectionMethod

  `INDS_PRODUCED, KEY_PARENTS`

  ### Fields inherited from class ec.BreedingSource

  `NO_PROBABILITY, P_PROB, probability`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BestSelection()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `void`
  `finishProducing(EvolutionState s, int subpopulation, int thread)`
  A default version of finishProducing, which does nothing.
  `void`
  `prepareToProduce(EvolutionState s, int subpopulation, int thread)`
  A default version of prepareToProduce which does nothing.
  `int`
  `produce(int subpopulation, EvolutionState state, int thread)`
  An alternative form of "produce" special to Selection Methods; selects an individual from the given subpopulation and returns its position in that subpopulation.
  `void`
  `setup(EvolutionState state, Parameter base)`
  Sets up the BreedingPipeline.

  ### Methods inherited from class ec.SelectionMethod

  `produce, produces, produceWithoutCloning, typicalIndsProduced`

  ### Methods inherited from class ec.BreedingSource

  `clone, fillStubs, getProbability, pickRandom, preparePipeline, setProbability, setupProbabilities`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_BEST

    public static final String P_BEST
    Default base
    See Also:
      - Constant Field Values

  - ### P_N

    public static final String P_N
    See Also:
      - Constant Field Values

  - ### P_N_FRACTION

    public static final String P_N_FRACTION
    See Also:
      - Constant Field Values

  - ### P_PICKWORST

    public static final String P_PICKWORST
    See Also:
      - Constant Field Values

  - ### P_SIZE

    public static final String P_SIZE
    See Also:
      - Constant Field Values

  - ### size

    public int size
    Base size of the tournament; this may change.

  - ### probabilityOfPickingSizePlusOne

    public double probabilityOfPickingSizePlusOne
    Probablity of picking the size plus one.

  - ### pickWorst

    public boolean pickWorst
    Do we pick the worst instead of the best?

  - ### sortedPop

    public int[] sortedPop
    Sorted, normalized, totalized fitnesses for the population

  - ### NOT_SET

    public static final int NOT_SET
    See Also:
      - Constant Field Values

  - ### bestn

    public int bestn

  - ### bestnFrac

    public double bestnFrac

- ## Constructor Details

  - ### BestSelection

    public BestSelection()

- ## Method Details

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Description copied from class: `BreedingSource`
    Sets up the BreedingPipeline. You can use state.output.error here because the top-level caller promises to call exitIfErrors() after calling setup. Note that probability might get modified again by an external source if it doesn't normalize right.

    The most common modification is to normalize it with some other set of probabilities, then set all of them up in increasing summation; this allows the use of the fast static BreedingSource-picking utility method, BreedingSource.pickRandom(...). In order to use this method, for example, if four breeding source probabilities are {0.3, 0.2, 0.1, 0.4}, then they should get normalized and summed by the outside owners as: {0.3, 0.5, 0.6, 1.0}.

    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`
    Overrides:
      `setup` in class `BreedingSource`
    See Also:
      - `Prototype.setup(EvolutionState,Parameter)`

  - ### prepareToProduce

    public void prepareToProduce(EvolutionState s, int subpopulation, int thread)
    Description copied from class: `SelectionMethod`
    A default version of prepareToProduce which does nothing.
    Overrides:
      `prepareToProduce` in class `SelectionMethod`

  - ### produce

    public int produce(int subpopulation, EvolutionState state, int thread)
    Description copied from class: `SelectionMethod`
    An alternative form of "produce" special to Selection Methods; selects an individual from the given subpopulation and returns its position in that subpopulation.
    Specified by:
      `produce` in class `SelectionMethod`

  - ### finishProducing

    public void finishProducing(EvolutionState s, int subpopulation, int thread)
    Description copied from class: `SelectionMethod`
    A default version of finishProducing, which does nothing.
    Overrides:
      `finishProducing` in class `SelectionMethod`